<template>
  <q-table
    class="table"
    :rows="rows"
    :columns="columns"
    row-key="name"
    :loading="loading"
    :pagination="pagination"
    table-style="border-radius: 10px; background-color: white;"
  >
    <template v-slot:body-cell-id="props">
      <q-td :props="props">
        {{ props.row.id }}
        <q-badge
          v-if="props.row.employer_read_at === null"
          rounded
          class="q-ml-md"
          >NEW</q-badge
        >
      </q-td>
    </template>

    <template v-slot:body-cell-created_at="props">
      <q-td :props="props">
        {{ formatDate(props.row.created_at) }}
      </q-td>
    </template>

    <template v-slot:body-cell-status="props">
      <q-td :props="props">
        <div v-if="props.row.status === 'pending'">In Review</div>
      </q-td>
    </template>

    <template v-slot:header-cell-actions="props">
      <q-th :props="props">
        <div class="title-xsmall text-grey-7">
          {{ rows.length > 1 ? rows.length + " JOBS" : rows.length + " JOB" }}
        </div>
      </q-th>
    </template>

    <template v-slot:body-cell-actions="props">
      <q-td :props="props">
        <div>
          <q-btn
            unelevated
            label="VIEW"
            class="btn-lg bg-positive text-white"
            @click="viewApplicantDetails(props.row)"
          />
        </div>
      </q-td>
    </template>

    <template v-slot:no-data="{ icon, message, filter }">
      <div class="full-width row flex-center q-gutter-sm">
        <q-icon
          v-if="message != 'Loading...'"
          size="25px"
          :name="filter ? 'filter_b_and_w' : icon"
        />
        <span style="font-size: 15px"> {{ message }} </span>
      </div>
    </template>
  </q-table>
</template>

<script>
import { TABLES } from "../../constants";
import { MY_JOBS_EMPLOYER_ROUTE_NAMES } from "../../constants";
import { defineComponent } from "vue";
import { LocalStorage } from "quasar";
import dayjs from "dayjs";
import usePageRouter from "src/hooks/pageRouter";

export default defineComponent({
  name: "PendingJobsTable",
  emits: ["viewJob"],
  props: {
    rows: {
      type: Array,
      default: () => {
        return [];
      },
    },
    loading: {
      type: Boolean,
      default: () => {
        return false;
      },
    },
  },
  setup(props, { emit }) {
    const { router } = usePageRouter();

    const formatDate = (date) => {
      return dayjs(date).format("MM/DD/YYYY");
    };

    const viewApplicantDetails = (job) => {
      emit("viewJob", job);
      LocalStorage.set("job_id", job.id);
      router.push({ name: MY_JOBS_EMPLOYER_ROUTE_NAMES.JobDetails.name });
    };

    return {
      columns: TABLES.PendingJobsTable.columns,
      formatDate,
      viewApplicantDetails,
      pagination: {
        rowsPerPage: 10,
      },
    };
  },
});
</script>

<style lang="sass">
.table
  max-height: 70vh

  .q-table__top,
  thead tr:first-child th
    background-color: #E9E9E8

  thead tr th
    position: sticky
    z-index: 1
  thead tr:first-child th
    top: 0

  &.q-table--loading thead tr:last-child th
    top: 48px
</style>

<style lang="scss">
div.q-table__container {
  background: #f1f1f1;
}
div.q-table__middle::-webkit-scrollbar-track {
  background: #ddd;
}
div.q-table__middle::-webkit-scrollbar {
  display: none;
}
div.q-table__middle {
  -ms-overflow-style: none;
  scrollbar-width: none;
}

div.q-table__bottom {
  border-top: 0;
}
</style>

<style lang="scss" scoped>
div.q-badge {
  height: 22px;
  padding: 4px 8px 5px 8px;
  background: #016925;
  border-radius: 50px;
  font-size: 11px;
  font-weight: 800;
}
</style>
